/*Made by Modelkitsdeluxe for
 * instructables and basic modeling techniques.
 * 
 * In this first part we will designate the libraries,
 * inputs and variables.
 */
 
#include <LiquidCrystal_I2C.h> //screen libraries
#include <Wire.h> //library for i2c

LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  

int rele=45; // relay pin
int botonamarillo=51; /// yellow button pin
int botonverde=53; // green button pin
int botonazul=47; // red button pin
int botonrojo=49; // blue button pin

int potenciometro=A3; //analog potentiometer pin
int presionentrada=A2; //analog total pressure transducer pin
int presionsalida=A1; //analog regulated pressure transducer pin

int pasos=0; //to count steps steps
int pul=13; //for pulse control
int dir=12; //to control the direction

float prdestino=0; //variable for the chosen pressure

float psientrada; //inlet pressure variable in PSI
float barentrada; //inlet pressure variable in bar

float psisalida;//variable outlet pressure in PSI
float barsalida;//variable outlet pressure in bar


float objetivo;//variable to read the potentiometer
int lobjetivo;//variable for potentiometer mapping
float probjetivo;//variable to add decimals

int accion=0;//variable to stop the engine once the pressure is reached
/*In this second part we will configure the pins,
 * your initial state, and we will write the greeting that
 * will only be read once.
 */
void setup(){
Serial.begin(9600);//serial begin
lcd.begin(20,4); //LCD begin

pinMode (rele, OUTPUT); //designates the pin as output
pinMode (botonamarillo, INPUT_PULLUP); //designates the pin as a pull up input
pinMode (botonverde, INPUT_PULLUP); //designates the pin as a pull up input
pinMode (botonazul, INPUT_PULLUP); ///designates the pin as a pull up input
pinMode (botonrojo, INPUT_PULLUP) ;//designates the pin as a pull up input
pinMode (dir, OUTPUT); //designates the pin as output
pinMode (pul, OUTPUT); //designates the pin as output

digitalWrite(rele, HIGH); //We turn off the relay initially
digitalWrite (pul, LOW); //We remove the pulses initially
digitalWrite (dir,LOW); //We remove the address initially

lcd.setCursor(5,0); //place the cursor at position 5 on line 0.
lcd.print("Super Air"); //we write on LCD
lcd.setCursor(5,1); //cursor at position 5 on line 1
lcd.print("Controller"); //we write on LCD
lcd.setCursor(11,3); //cursor at position 14 on line 3
lcd.print("By T.B.M."); //we write on LCD
delay(1500); //we wait a second and a half
      lcd.clear(); // We delete and write the options on the screen
      lcd.setCursor(0,0); 
      lcd.print ("In pressure      Bar");
      lcd.setCursor (0,1);
      lcd.print ("OUT Pressur      Bar");
      lcd.setCursor (0,2);
      lcd.print ("   Select Pressure  ");
      lcd.setCursor(0,3); 
      lcd.print (" 0.8 "); 
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); 
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); 
      lcd.setCursor(15,3); 
      lcd.print ("     "); //here the reading of the potentiometer converted to bars will appear
}
/*In this last part, it will read the sensors, write on the screen,  
 * and the program will run constantly.
 */
void loop(){
   
   objetivo = analogRead(potenciometro); //read the potentiometer
   lobjetivo = map(objetivo, 0, 1023, 7, 30); //sets the desired pressure scale in this case from 0.7 bars to 3 bars
   probjetivo = lobjetivo/10.0; //put decimals
   lcd.setCursor (16,3); //place the cursor in the space provided for it
   lcd.print(probjetivo,1); //write the result with a decimal

   psientrada = 43.5 * (5.0*analogRead(presionentrada)/1023.0 - 0.5); //simplified transducer reading
   barentrada = (psientrada/14.5); //we convert psi into bars
   lcd.setCursor (12,0); //place the cursor on the input pressure
   lcd.print(barentrada,1); //write the result with a decimal

   psisalida = 37.5 * (5.0*analogRead(presionsalida)/1023.0 - 0.5); //simplified transducer reading
   barsalida = (psisalida/14.5); //we convert psi into bars
   lcd.setCursor (12,1); //place the cursor on the output pressure
   lcd.print(barsalida, 1); //write the result with a decimal
   
  if (digitalRead(botonverde)==LOW){ //if the green button is pressed
      lcd.setCursor(0,3); 
      lcd.print ("[0.8]"); //mark 0.8 with two square brackets
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); 
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); 
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=0.8; //we set the target pressure to 0.8 in this case
      accion=1;// activate action, going from 0 to 1
  }
    if (digitalRead(botonamarillo)==LOW){ //same as the previous case only this time 1.2 is set as the destination
      lcd.setCursor(0,3); 
      lcd.print (" 0.8 "); 
      lcd.setCursor (5,3);
      lcd.print ("[1.2]"); //mark 1.2 with two square brackets
      lcd.setCursor (10,3);
      lcd.print (" 2.0 ");
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=1.2; //we set the target pressure to 1.2 in this case
      accion=1; // activate action, going from 0 to 1
  }
    if (digitalRead(botonrojo)==LOW){ //same as the previous case only this time 2.0 is set as the destination
      lcd.setCursor(0,3); 
      lcd.print (" 0.8 ");
      lcd.setCursor (5,3);
      lcd.print (" 1.2 ");
      lcd.setCursor (10,3);
      lcd.print ("[2.0]"); //mark 2.0 with two square brackets
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=2.0;//we set the target pressure to 2.0 in this case
      accion=1; // activate action, going from 0 to 1
  }
    if (digitalRead(botonazul)==LOW){ //same as the previous case only this time target is set as the destination

      lcd.setCursor(0,3); 
      lcd.print (" 0.8 ");
      lcd.setCursor (5,3);
      lcd.print (" 1.2 ");
      lcd.setCursor (10,3);
      lcd.print (" 2.0 ");
      lcd.setCursor(15,3); 
      lcd.print ("[   ]");//mark with brackets the space where the target pressure will be written
      prdestino=probjetivo; //the target pressure becomes equal to the desired pressure
      accion=1; // activate action, going from 0 to 1
  }
   
if(barentrada>prdestino && accion==1){ //if the inlet pressure is greater than the one set at destination and action is activated (1) then:
   
   if (barsalida < prdestino){//turns the motor clockwise if the target pressure is higher

       digitalWrite(dir,LOW); //set left direction
       digitalWrite(pul,HIGH); //we activate a pulse
       delayMicroseconds(10); //we wait 10microseconds
       digitalWrite(pul,LOW); //we turn off the pulse
       delayMicroseconds(10); //we wait 10microseconds
       if (barsalida > prdestino-0.01){//When the destination pressure -0.01 is less than the output pressure
      digitalWrite(dir,LOW); // turn off direction
      digitalWrite(pul,LOW); //we turn off pulses
      lcd.setCursor(0,3); //write all the boxes eliminating the square brackets
      lcd.print (" 0.8 "); 
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); 
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); 
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=0; //remove the target pressure value
      accion=0; //We stop the movement of the motor in one direction or another by passing action to 0, an essential condition for movement.
       }
   }
   if (barsalida > prdestino){ //turns the motor clockwise if the target pressure is lower
        digitalWrite(dir,HIGH); //set right direction
       digitalWrite(pul,HIGH);//we activate a pulse
       delayMicroseconds(10); //we wait 10microseconds
       digitalWrite(pul,LOW); we turn off pulses
       delayMicroseconds(10); //we wait 10microseconds
       pasos++; //add a step by performing this action once
        if (pasos==300){ //on a loose turn releases pressure to take real measurements and resets the step counter to 0
        digitalWrite(rele,LOW); // activate relay
        delay(150); //wait 150 milliseconds
        digitalWrite (rele,HIGH); //turn off the relay
        pasos=0; //set steps to 0
       }
      if (barsalida < prdestino+0.01){//When the destination pressure +0.01 is greater than the output pressure
      digitalWrite(dir,LOW); // turn off direction
      digitalWrite(pul,LOW); //we turn off pulses
      lcd.setCursor(0,3); //write all the boxes eliminating the square brackets
      lcd.print (" 0.8 "); 
      lcd.setCursor (5,3);
      lcd.print (" 1.2 "); 
      lcd.setCursor (10,3);
      lcd.print (" 2.0 "); 
      lcd.setCursor(15,3); 
      lcd.print ("     ");
      prdestino=0; //remove the target pressure value
      accion=0; //We stop the movement of the motor in one direction or another by passing action to 0, an essential condition for movement.
       }
    }
  }
}
